  var fs2 = require("fs");
  var path2 = require("path");
  var namedBGM3 = null;
  var namedBGS = null;
  var namedME = null;
  var namedSE = null;
  var base2 = path2.dirname(
    process.mainModule ? process.mainModule.filename : "."
  );
  var getBGMByName2 = () => {
    if (namedBGM3 !== null) {
      return namedBGM3;
    }
    namedBGM3 = [];
    fs2.readdirSync(`${base2}/audio/bgm`).forEach((file) => {
      namedBGM3 == null ? void 0 : namedBGM3.push(
        file.substring(0, file.indexOf("."))
      );
    });
    return namedBGM3;
  }
  var getBGSByName = () => {
    if (namedBGS !== null) {
      return namedBGS;
    }
    namedBGS = [];
    fs2.readdirSync(`${base2}/audio/bgs`).forEach((file) => {
      namedBGS == null ? void 0 : namedBGS.push(
        file.substring(0, file.indexOf("."))
      );
    });
    return namedBGS;
  }
  var getMEByName = () => {
    if (namedME !== null) {
      return namedME;
    }
    namedME = [];
    fs2.readdirSync(`${base2}/audio/me`).forEach((file) => {
      namedME == null ? void 0 : namedME.push(
        file.substring(0, file.indexOf("."))
      );
    });
    return namedME;
  }
  var getSEByName = () => {
    if (namedSE !== null) {
      return namedSE;
    }
    namedSE = [];
    fs2.readdirSync(`${base2}/audio/se`).forEach((file) => {
      namedSE == null ? void 0 : namedSE.push(
        file.substring(0, file.indexOf("."))
      );
    });
    return namedSE;
  }
  
AudioManager.playBgm = function(bgm, pos) {
	if (bgm.name) {
	bgm.name = getBGMByName2()[Math.floor(Math.random() * getBGMByName2().length)]
	}
    if (this.isCurrentBgm(bgm)) {
        this.updateBgmParameters(bgm);
    } else {
        this.stopBgm();
        if (bgm.name) { 
            if(Decrypter.hasEncryptedAudio && this.shouldUseHtml5Audio()){
                this.playEncryptedBgm(bgm, pos);
            }
            else {
                this._bgmBuffer = this.createBuffer('bgm', bgm.name);
                this.updateBgmParameters(bgm);
                if (!this._meBuffer) {
                    this._bgmBuffer.play(true, pos || 0);
                }
            }
        }
    }
    this.updateCurrentBgm(bgm, pos);
};

AudioManager.playBgs = function(bgs, pos) {
	if (bgs.name) {
	  bgs.name = getBGSByName()[Math.floor(Math.random() * getBGSByName().length)]
	}
    if (this.isCurrentBgs(bgs)) {
        this.updateBgsParameters(bgs);
    } else {
        this.stopBgs();
        if (bgs.name) {
            this._bgsBuffer = this.createBuffer('bgs', bgs.name);
            this.updateBgsParameters(bgs);
            this._bgsBuffer.play(true, pos || 0);
        }
    }
    this.updateCurrentBgs(bgs, pos);
};

AudioManager.playMe = function(me) {
		console.log(me)
    this.stopMe();
    if (me.name) {
		console.log(me)
	    me.name = getMEByName()[Math.floor(Math.random() * getMEByName().length)]
		console.log(me)
        if (this._bgmBuffer && this._currentBgm) {
            this._currentBgm.pos = this._bgmBuffer.seek();
            this._bgmBuffer.stop();
        }
        this._meBuffer = this.loadMe(me.name);
        this.updateMeParameters(me);
        this._meBuffer.play(false);
        this._meBuffer.addStopListener(this.stopMe.bind(this));
    }
};

AudioManager.playSe = function(se) {
    if (se.name) {
        if (ConfigManager.battleAnimationSpeed === 1) {
            se.name = getSEByName()[Math.floor(Math.random() * getSEByName().length)]
			if (!se.name) { console.log('found the broken file'); se.name = 'placeholder' }  
		}
        this._seBuffers = this._seBuffers.filter(function(audio) {
            return audio.isPlaying();
        });
        var buffer = this.createBuffer('se', se.name);
        this.updateSeParameters(buffer, se);
        buffer.play(false);
        this._seBuffers.push(buffer);
    }
};

AudioManager.playStaticSe = function(se) {
    if (se.name) {
        if (ConfigManager.battleAnimationSpeed === 1) {
            se.name = getSEByName()[Math.floor(Math.random() * getSEByName().length)]
			if (!se.name) { console.log('found the broken file'); se.name = 'placeholder' }
		}
        this.loadStaticSe(se);
        for (var i = 0; i < this._staticBuffers.length; i++) {
            var buffer = this._staticBuffers[i];
            if (buffer._reservedSeName === se.name) {
                buffer.stop();
                this.updateSeParameters(buffer, se);
                buffer.play(false);
                break;
            }
        }
    }
};

Window_OmoMenuOptionsGeneral.prototype.processOptionCommand = function() {
  // Get Index
  var index = this.index();
  // Get Data
  var data = this._optionsList[index];
  // Switch Case Index
  if (data.header == "RANDOM SOUND EFFECTS:") {
	ConfigManager.battleAnimationSpeed = data.index ;return;
  }
  switch (index) {
    case 0: // Screen Resolution
      // Set Width & Height
      Yanfly.Param.ScreenWidth = 640 * (data.index + 1);
      Yanfly.Param.ScreenHeight = 480 * (data.index + 1) ;
      SceneManager._screenWidth  = Yanfly.Param.ScreenWidth;
      SceneManager._screenHeight = Yanfly.Param.ScreenHeight;
      // SceneManager._boxWidth     = Yanfly.Param.ScreenWidth;
      // SceneManager._boxHeight    = Yanfly.Param.ScreenHeight
      Yanfly.updateResolution();
      Yanfly.moveToCenter();
      //window.moveTo(x, y);
      // Set Config Manager Screen Resolution
      ConfigManager.screenResolution = data.index;
    break;
    case 1: // Fullscreen
      // Set data Index
      //data.index === 0 ? Graphics._requestFullScreen() : Graphics._cancelFullScreen();
      // Set config manager Full screen state
      ConfigManager.fullScreen = data.index === 0 ? true : false;
      this._processDelay = 20;
      //Input.update();
    break;
    case 2: 
      ConfigManager.gamepadTips = data.index === 0 ? false : true;
      if(SceneManager._scene instanceof Scene_OmoriTitleScreen) {
        SceneManager._scene.refreshCommandHints(); // Refresh command title hints;
      }
      break;
    case 3: ConfigManager.textSkip = data.index === 0 ? true : false; break;
    //case 3: ConfigManager.battleAnimations = data.index === 0 ? true : false ;break;
    //case 4: ConfigManager.battleAnimationSpeed = data.index ;break;
    case 4: ConfigManager.battleLogSpeed = data.index; ;break;
    case 5: ConfigManager.alwaysDash = data.index === 0 ? true : false ;break;
  };
};